#ifndef MyView_H
#define MyView_H

#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <windows.h>
#include "stdafx.h"

CMutex g_m;
//CRITICAL_SECTION m_cs;
class MyView : public SoWinExaminerViewer  {
public:
	MyView(HWND a):SoWinExaminerViewer(a){
	

	//Initilize the critical section
	//InitializeCriticalSection(&m_cs);
	}

	void render(){
		// Create object for Single Lock
		CSingleLock lock(&g_m);

		lock.Lock();
		// Lock the Critical section
		//EnterCriticalSection(&m_cs);

		SoWinExaminerViewer::render();

		//Release the Critical section
		//LeaveCriticalSection(&m_cs);
		
		lock.Unlock();
	}


};
#endif //MyView_H