#ifndef View_H
#define View_H

#include <windows.h>
#include <winbase.h>
#include <string.h>
#include "osinterface.h"
#include "celula.h"
#include "valores.h"
//*********************************TODO EL VIAJE DE COIN3D Y SOWIN **********
#include <Inventor/Win/SoWin.h>

#include <Inventor/Win/SoWinRenderArea.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoDirectionalLight.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoGroup.h>

#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoTranslation.h>

#include <Inventor/nodes/SoFaceSet.h>

#include <Inventor/nodes/SoTexture2.h>
//*************************************************************************


static SoTexture2 *texturas[states];
static celula *grid[xmax][ymax];
static SoSeparator* root;

static int jjj = 1;
 
class View :  public SoOsInterface{


void cargaImagenes(){
	
	for(int i = 0; i < 7; ++i){
		texturas[i] = new SoTexture2();
		texturas[i]->ref();
	}
		
	texturas[0]->filename.setValue("1.png");
	texturas[1]->filename.setValue("2.png");
	texturas[2]->filename.setValue("3.png");
	texturas[3]->filename.setValue("4.png");
	texturas[4]->filename.setValue("5.png");
	texturas[5]->filename.setValue("6.png");
	texturas[6]->filename.setValue("7.png");	
}

	
public: 
	bool soRendering;
	
	
	View(){
		printf("view creada\n");
		soRendering = false;
	}
	~View(){}
	
	SoSeparator* createRoot(){
		

		root = new SoSeparator;
		root->ref();
	
		cargaImagenes();
		celula::initClass();
		for(int i =0; i< xmax;++i)
			for(int j = 0; j < ymax; ++j){
				grid[i][j] = new celula;
				grid[i][j]->setTexture(texturas[statesMatrix[i][j]]);
				grid[i][j]->init();
				grid[i][j]->SetPosition(SbVec3f(float(i), float(j), .0f));
				
				root->addChild(grid[i][j]);
			}
		
		
		return root;
	}

	void freeRoot()
	{
        // Deallocate the root node and everything under it
		root->unref();
        root = NULL;
	}
	void doUpdates()
	{
		for(int i = 0; i<xmax;++i)
		for(int j = 0; j<ymax;++j){
			grid[i][j]->replaceChild(grid[i][j]->textura,texturas[statesMatrix[i][j]]);
			grid[i][j]->setTexture(texturas[statesMatrix[i][j]]);
		}
			
	}// FIN DO UPDATES

};
#endif //View_H