#ifndef Model_H
#define Model_H


#include <windows.h>
#include "Thread.h"

#include "View.h"
#include "SyncronousAutomaton.h"
#include  "valores.h"
// Global Mutex Object
CMutex g_m;
//CRITICAL_SECTION m_cs;

class Model : public CThread{

	View* view;
	SyncronousAutomaton<int> *automaton2d;
	
public:
	
	void ThreadCtor(View* v){
		view = v;
	
		init(); 
		//printf("model  constructor----------------------------- \n");
		
		automaton2d = new SyncronousAutomaton<int>
		(&statesMatrix[0][0], &statesMatrixnt1[0][0], dimSizes2D, dimencions2D); 
		automaton2d->iterateOverTheSatesArray();

		//Initilize the critical section
		//InitializeCriticalSection(&m_cs);
			
		//printf("fin model  constructor----------------------------- \n");
		
	}
	~Model(){}
	virtual DWORD Run( LPVOID arg ){
		//printf("model  antes de wile----------------------------- \n");
		int plusOne;
		bool flag = false;
		Sleep(10000);
		while(1)
        {
			Sleep(1500);
			////////////RULE/////////////////////////////
			flag = false;
			for(int i = 0; i < xmax*ymax; ++i){
				plusOne = *(automaton2d->graph[i].centerCell) + 1;
				if(plusOne == states)
					plusOne = 0;
				for(int j = automaton2d->graph[i].beginNeighbor; j <= automaton2d->graph[i].endNeighbor; ++j){
					if(*(automaton2d->neighbors[j]) == plusOne){
						*(automaton2d->graph[i].centerCellTPlusOne) = plusOne;
						flag = true;
						break;
					}
				}
				if(!flag)
					*(automaton2d->graph[i].centerCellTPlusOne) = *(automaton2d->graph[i].centerCell);
			}
			///////////////RULE///////////////////////////////

			/*sicronize*/
			for(int i = 0; i < xmax*ymax; ++i)
			*(automaton2d->graph[i].centerCell) = *(automaton2d->graph[i].centerCellTPlusOne);
			

			/*/ Lock the Critical section
			EnterCriticalSection(&m_cs);

			// Some Process
			View::cambia();

			//Release the Critical section
			LeaveCriticalSection(&m_cs);
			*/
			// Create object for Single Lock
			printf("model ----------------------------- a cambiar imagenes \n");
			CSingleLock lock(&g_m);

			lock.Lock();
			//update view
			view->postUpdates();
			lock.Unlock();
			
			
		}
		
		return 0;
	}
};

#endif //Model_H