#include "celula.h"
SO_NODE_SOURCE(celula);
void celula::initClass()
{
	//printf(" init class method\n");
   // Initialize type id variables. The arguments to the macro
   // are: the name of the node class, the class this is derived
   // from, and the name registered with the type of the parent
   // class.
   SO_NODE_INIT_CLASS(celula, SoSeparator, "Separator");
}
celula::celula(){
	//printf(" constructor\n");
		SO_NODE_CONSTRUCTOR(celula);
		//this->affectsState(true);
		/*SO_NODE_ADD_FIELD(textura, new SoTexture2);
		SO_NODE_ADD_FIELD(trans, new SoTranslation);
		SO_NODE_ADD_FIELD(coords, new SoCoordinate3);
		SO_NODE_ADD_FIELD(face, new SoFaceSet);   
		*/
}
celula::celula(const celula& cel): textura(cel.textura), trans(cel.trans), coords(cel.coords), face(cel.face){
	//printf("copy constructor\n");	
	// Do standard constructor tasks
		SO_NODE_CONSTRUCTOR(celula);
		this->addChild(textura);
		this->addChild(trans);
		this->addChild(coords);
		this->addChild(face);
}
celula::~celula(){}
//en init se crea la cara
void celula::init(){
	//printf(" init \n");
		//pones la textura
		this->addChild(textura);
		trans = new SoTranslation;
		//pones las cordenadas de un cuadrado de lado uno
		coords = new SoCoordinate3;
		coords->point.set1Value(0, SbVec3f(0, 0, 0));
		coords->point.set1Value(1, SbVec3f(1, 0, 0));
		coords->point.set1Value(2, SbVec3f(1, 1, 0));
		coords->point.set1Value(3, SbVec3f(0, 1, 0));
		face = new SoFaceSet;
		//pones la cara, sus cordenadas y la tranlacion
		this->addChild(trans);
		this->addChild(coords);
		this->addChild(face);
		//y le diece a la car el numero de vertices aue tiene
		face->numVertices.setValue(4);
}
void celula::setTexture(SoTexture2 *text){
	textura = text;
}
void celula::SetPosition(SbVec3f pos){
	//printf(" set position\n");
	trans->translation = pos;
}

void celula::copyContents(const celula * from, SbBool copyconnections){

	SoSeparator::copyContents(from, copyconnections);
	this->textura = from->textura;
	this->trans = from->trans;
	this->coords = from->coords;
	this->face = from->face;
}
celula& celula::operator=(const celula& cel) {
    textura = cel.textura; 
	trans = cel.trans; 
	coords = cel.coords;
	face = cel.face;
	
	return *this;
  }
void celula::replaceChild(SoNode *oldchild, SoNode *newchild){
	SoSeparator::replaceChild(oldchild, newchild);
}